From 49bbf085bb6c7712a2b8ed8f62b066f4f8040697 Mon Sep 17 00:00:00 2001
From: nbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>
Date: Sat, 22 Oct 2005 20:47:19 +0000
Subject: sync base-files with whiterussian

git-svn-id: svn://svn.openwrt.org/openwrt/trunk@2260 3c298f89-4303-0410-b956-a3cf2f4a3e73
---
 .../package/base-files/default/etc/functions.sh    | 50 +++++++++++++
 .../package/base-files/default/etc/init.d/S10boot  | 20 +-----
 openwrt/package/base-files/default/etc/profile     |  1 +
 openwrt/package/base-files/default/sbin/ifdown     |  6 +-
 openwrt/package/base-files/default/sbin/ifup       | 82 +++++++---------------
 5 files changed, 82 insertions(+), 77 deletions(-)

diff --git a/openwrt/package/base-files/default/etc/functions.sh b/openwrt/package/base-files/default/etc/functions.sh
index c813e39a6..bc9767f49 100755
--- a/openwrt/package/base-files/default/etc/functions.sh
+++ b/openwrt/package/base-files/default/etc/functions.sh
@@ -24,6 +24,56 @@ if_valid () (
   { debug "# missing interface '$1' ignored"; false; }
 )
 
+do_ifup() {
+	if_proto=$(nvram get ${2}_proto)
+	if=$(nvram get ${2}_ifname)
+	[ "${if%%[0-9]}" = "ppp" ] && if=$(nvram get ${if_proto}_ifname)
+	
+	pidfile=/var/run/${if}.pid
+	[ -f $pidfile ] && $DEBUG kill $(cat $pidfile)
+
+	case "$1" in
+	static)
+		ip=$(nvram get ${2}_ipaddr)
+		netmask=$(nvram get ${2}_netmask)
+		gateway=$(nvram get ${2}_gateway)
+
+		$DEBUG ifconfig $if $ip ${netmask:+netmask $netmask} broadcast + up
+		${gateway:+$DEBUG route add default gw $gateway}
+
+		[ -f /etc/resolv.conf ] && return
+
+		debug "# --- creating /etc/resolv.conf ---"
+		for dns in $(nvram get ${2}_dns); do
+			echo "nameserver $dns" >> /etc/resolv.conf
+		done
+	;;
+	dhcp)
+		DHCP_IP=$(nvram get ${2}_ipaddr)
+		DHCP_NETMASK=$(nvram get ${2}_netmask)
+		$DEBUG ifconfig $if $ip ${netmask:+netmask $netmask} broadcast + up
+
+		DHCP_ARGS="-i $if ${DHCP_IP:+-r $DHCP_IP} -b -p $pidfile"
+		DHCP_HOSTNAME=$(nvram get ${2}_hostname)
+		DHCP_HOSTNAME=${DHCP_HOSTNAME%%.*}
+		[ -z $DHCP_HOSTNAME ] || DHCP_ARGS="$DHCP_ARGS -H $DHCP_HOSTNAME"
+		[ "$if_proto" = "pptp" ] && DHCP_ARGS="$DHCP_ARGS -n -q" || DHCP_ARGS="$DHCP_ARGS -R &"
+		oldpid=$(cat $pidfile)
+		${DEBUG:-eval} "udhcpc $DHCP_ARGS"
+		pidof udhcpc | grep "$oldpid" >&- 2>&- && {
+			sleep 1
+			kill -9 $oldpid
+		}
+	;;
+	none|"")
+	;;
+	*)
+		[ -x "/sbin/ifup.$1" ] && { $DEBUG /sbin/ifup.$1 ${2}; exit; }
+		echo "### ifup ${2}: ignored ${2}_proto=\"$1\" (not supported)"
+	;;
+	esac
+}
+
 bitcount () {
   local c=$1
   echo $((
diff --git a/openwrt/package/base-files/default/etc/init.d/S10boot b/openwrt/package/base-files/default/etc/init.d/S10boot
index 66fece1d7..b0dc04eb7 100755
--- a/openwrt/package/base-files/default/etc/init.d/S10boot
+++ b/openwrt/package/base-files/default/etc/init.d/S10boot
@@ -10,30 +10,12 @@ mkdir -p /var/log
 touch /var/log/wtmp
 touch /var/log/lastlog
 
-[ -x /usr/sbin/nvram ] && {
-  [ "$(nvram get il0macaddr)" = "00:90:4c:5f:00:2a" ] && {
-    # if default wifi mac, set two higher than the lan mac
-    nvram set il0macaddr=$(nvram get et0macaddr|
-    awk '{OFS=FS=":";for(x=7,y=2;--x;){$x=sprintf("%02x",(y+="0x"$x)%256);y/=256}print}')
-  }
-
-  # set up the vlan*ports variables for the asus wl-500g deluxe
-  # if they don't already exist 
-  [  "$(nvram get boardtype)" = "bcm95365r" \
-  -a "$(nvram get boardnum)" = "45" \
-  -a -z "$(nvram get vlan0ports)" \
-  -a -z "$(nvram get vlan1ports)" ] && {
-  	nvram set vlan0ports="1 2 3 4 5*"
-  	nvram set vlan1ports="0 5"
-  }
-}
-
 sed 's/^[^#]/insmod &/' /etc/modules /etc/modules.d/* 2>&-|ash
 
 ifconfig lo 127.0.0.1 up
 ifconfig eth0 promisc
 
-[ "$(uname -r|grep -c 2.6)" = "1" ] && [ -x /sbin/robocfg ] && {
+[ "$(uname -r|grep -c 2.6)" = "1" ] && [ -x /sbin/robocfg ] && { # FIXME: replace when the new switch driver is integrated...
   robocfg switch disable vlans enable reset vlan 0 ports "0 1 2 3 5t" vlan 1 ports "4 5t" port 4 state enabled stp none switch enable
   robocfg show
 }
diff --git a/openwrt/package/base-files/default/etc/profile b/openwrt/package/base-files/default/etc/profile
index 1d98ae340..e3abe6967 100644
--- a/openwrt/package/base-files/default/etc/profile
+++ b/openwrt/package/base-files/default/etc/profile
@@ -9,3 +9,4 @@ alias vim=vi
 
 arp() { cat /proc/net/arp; }
 ldd() { LD_TRACE_LOADED_OBJECTS=1 $*; }
+reboot() { ifdown wan 2>&1 >/dev/null ; /sbin/reboot; }
diff --git a/openwrt/package/base-files/default/sbin/ifdown b/openwrt/package/base-files/default/sbin/ifdown
index 2d4054d8b..147136949 100755
--- a/openwrt/package/base-files/default/sbin/ifdown
+++ b/openwrt/package/base-files/default/sbin/ifdown
@@ -6,6 +6,8 @@
 type=$1
 debug "### ifdown $type ###"
 if=$(nvram get ${type}_ifname)
-if_valid $if || exit 
-$DEBUG ifconfig $if down
+proto=$(nvram get ${type}_proto)
+if_valid $if && $DEBUG ifconfig $if down
 kill $(cat /var/run/${if}.pid 2>&-) 2>&-
+[ "$if" = "ppp0" ] && killall pppd
+killall ifup.$proto >&- 2>&-
diff --git a/openwrt/package/base-files/default/sbin/ifup b/openwrt/package/base-files/default/sbin/ifup
index 1f78061a2..be7075bf1 100755
--- a/openwrt/package/base-files/default/sbin/ifup
+++ b/openwrt/package/base-files/default/sbin/ifup
@@ -1,5 +1,6 @@
 #!/bin/ash
 [ $# = 0 ] && { echo "  $0 <group>"; exit; }
+
 . /etc/functions.sh
 . /etc/network.overrides
 [ "$FAILSAFE" != "true" -a -e /etc/config/network ] && . /etc/config/network
@@ -8,59 +9,28 @@ type=$1
 debug "### ifup $type ###"
 
 if_proto=$(nvram get ${type}_proto)
-[ "${if_proto}" = "pppoa" ] || {
-	if=$(nvram get ${type}_ifname)
-	[ "${if%%[0-9]}" = "ppp" ] && if=$(nvram get ${if_proto}_ifname)
-
-	if_valid $if || exit 
-	mac=$(nvram get ${type}_hwaddr)
-	$DEBUG ifconfig $if down 2>&-
-
-	pidfile=/var/run/${if}.pid
-	[ -f $pidfile ] && $DEBUG kill $(cat $pidfile)
-
-	if [ "${if%%[0-9]}" = "br" ]; then
-		stp=$(nvram get ${type}_stp)
-		$DEBUG brctl delbr $if 2>&-
-		$DEBUG brctl addbr $if
-		$DEBUG brctl setfd $if 0
-		$DEBUG brctl stp $if ${stp:-0}
-
-		for sif in $(nvram get ${type}_ifnames); do
-			if_valid $sif || continue
-			${mac:+$DEBUG ifconfig $sif down hw ether $mac}
-			$DEBUG ifconfig $sif 0.0.0.0 up
-			$DEBUG brctl addif $if $sif
-		done
-	else
-		${mac:+$DEBUG ifconfig $if down hw ether $mac}
-	fi
-}
-
-case "$if_proto" in
-	static)
-		ip=$(nvram get ${type}_ipaddr)
-		netmask=$(nvram get ${type}_netmask)
-		gateway=$(nvram get ${type}_gateway)
-
-		$DEBUG ifconfig $if $ip ${netmask:+netmask $netmask} broadcast + up
-		${gateway:+$DEBUG route add default gw $gateway}
-
-		[ -f /etc/resolv.conf ] && return
-
-		debug "# --- creating /etc/resolv.conf ---"
-		for dns in $(nvram get ${type}_dns); do
-			echo "nameserver $dns" >> /etc/resolv.conf
-		done
-	;;
-	dhcp)
-		ip=$(nvram get ${type}_ipaddr)
-		${DEBUG:-eval} "udhcpc -R -i $if ${ip:+-r $ip} -b -p $pidfile &" 
-	;;
-	none|"")
-	;;
-	*)
-		[ -x "/sbin/ifup.${if_proto}" ] && { $DEBUG /sbin/ifup.${if_proto} $*; exit; }
-		echo "### ifup $type: ignored ${type}_proto=\"$if_proto\" (not supported)"
-	;;
-esac
+if=$(nvram get ${type}_ifname)
+[ "${if%%[0-9]}" = "ppp" ] && if=$(nvram get ${if_proto}_ifname)
+
+if_valid $if || [ "$if_proto" = "pptp" ] || exit 
+mac=$(nvram get ${type}_hwaddr)
+$DEBUG ifconfig $if down 2>&-
+
+if [ "${if%%[0-9]}" = "br" ]; then
+	stp=$(nvram get ${type}_stp)
+	$DEBUG brctl delbr $if 2>&-
+	$DEBUG brctl addbr $if
+	$DEBUG brctl setfd $if 0
+	$DEBUG brctl stp $if ${stp:-0}
+
+	for sif in $(nvram get ${type}_ifnames); do
+		if_valid $sif || continue
+		${mac:+$DEBUG ifconfig $sif down hw ether $mac}
+		$DEBUG ifconfig $sif 0.0.0.0 up
+		$DEBUG brctl addif $if $sif
+	done
+else
+	${mac:+$DEBUG ifconfig $if down hw ether $mac}
+fi
+
+do_ifup $if_proto $type
-- 
cgit v1.2.3